--  scale.e: scaling of sequences (images)
--  j.babor@gns.cri.nz
--  version 1.0  98-07-23
--  version 1.1  98-07-27
--  incorporates elegant enhancements by Colin Taylor - about 25% faster
--  inner loop of scale_image() tweaked by Rob Craig

function scale_index(integer N,integer n)
    -- generate index sequence to remap sequence of length N to new length n
    sequence s
    integer i,j,nn,nN,NN,dx,dX,e
    s=repeat(0,n)
    if n=N then for k=1 to n do s[k]=k end for
    else
	nn=n*n
	nN=n*N
	NN=N*N
	dx=2*(NN-nN)
	dX=2*(nN-nn)
	e=nN-NN
	if n>N then
	    dx=-dx
	    dX=-dX
	    e=-e
	end if
	i=0
	j=0
	while j<n do
	    if e<0 then
		i=i+1
		e=e+dX
	    else
		j=j+1
		s[j]=i
		e=e-dx
	    end if
	end while
    end if
    return s
end function

global function scale_image(sequence im,integer w,integer h)
    -- remap *rectangular* sequence im to new width w and height h
    sequence r,s,t
    sequence ti, imri
    integer l
    l=length(im)
    r=scale_index(l,h)
    l=length(im[1])
    s=scale_index(l,w)
    t=repeat(repeat(0,w),h)
    for i=1 to h do
	ti = t[i] 
	imri = im[r[i]]
	for j=1 to w do ti[j]=imri[s[j]] end for
	t[i] = ti
    end for
    return t
end function

